Bug 64162 - /dev/random broken /proc/sys/kernel/random/entropy_avail always 0 kernel-2.4.9-31
/dev/random broken /proc/sys/kernel/random/entropy_avail always 0 kernel-2.4....
Status: CLOSED CURRENTRELEASE
Product: Red Hat Linux
Classification: Retired
Component: kernel (Show other bugs)
7.2
i686 Linux
medium Severity medium
: ---
: ---
Assigned To: Arjan van de Ven
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2002-04-26 17:59 EDT by Jerry Williams
Modified: 2008-08-01 12:22 EDT (History)
0 users

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2004-09-30 11:39:32 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description Jerry Williams 2002-04-26 17:59:12 EDT
From Bugzilla Helper:
User-Agent: Mozilla/4.79 [en] (Windows NT 5.0; U)

Description of problem:
This only seems to happen on Compaq hardware.
/proc/sys/kernel/random/entropy_avail is always 0 never changes.
So everything block when reading /dev/random and never gets anything.

Version-Release number of selected component (if applicable):


How reproducible:
Always

Steps to Reproduce:
1. Install RedHat 7.2
2. use the kernel-2.4.9-31
3. cat /proc/sys/kernel/random/entropy_avail returns 0
	

Expected Results:  cat /proc/sys/kernel/random/entropy_avail
should return a number other than 0 most of the time.

Additional info:

I have a problem with this on 3 Compaq machines.
I have gone back to kernel-2.4.7-10 and it works ok.
I'm not sure if this causes security problems or not, since /dev/random doesn't work.
I found it trying to use rndc-confgen -a.  It never returns, because it blocks on /dev/random.
Comment 1 Jerry Williams 2002-04-26 20:06:48 EDT
It turns out the entropy is only collected  by the console mouse and keyboard.   If there are others I would like to know what they are.
So until someone moves the mouse or touches the keyboard there is nothing in /dev/random to be used.
Most of the time I am not at the console, but since I was changing what kernel I was using I was at the console and figured this out.
So don't try and run rndc-confgen if you aren't at the console ;-).
So I am not sure if this is still a bug or not.
Comment 2 Arjan van de Ven 2002-04-27 03:07:09 EDT
SCSI and IDE io also generates entropy.
Network IO doesn't (the theory is that that's an outside controlled source)...


Some chipsets (intel i8xx and newer AMD ones) have an on board RNG, as do
hardware SSL accelerators usually.
Comment 3 Jerry Williams 2002-04-27 14:51:31 EDT
Well I tried to do some IO and it doesn't seem to do anything.  All of the machines that I have a problem with are SCSI.
I did a dd if=/dev/cciss/c0d0p14 of=/dev/null bs=32k this is like a 9Gig partion and cat /proc/sys/kernel/random/entropy_avail still
returns 0.  So  maybe there is a problem with the SCSI code.

$ lsmod
Module                  Size  Used by    Tainted: PF
autofs                 11556   0  (autoclean) (unused)
cpqhealth             670444   0
cpqrom                 23076   0  [cpqhealth]
eepro100               17680   1
st                     26324   0  (unused)
usb-ohci               19872   0  (unused)
usbcore                51808   1  [usb-ohci]
ext3                   62624  11
jbd                    41092  11  [ext3]
aic7xxx               114624   0  (unused)
cciss                  38528  12
sd_mod                 11900   0  (unused)
scsi_mod               98584   3  [st aic7xxx cciss sd_mod]

[root@dhcp9 root]# lsmod
Module                  Size  Used by    Not tainted
loop                    9168   0  (unused)
autofs                 11556   0  (autoclean) (unused)
eepro100               17680   1
ext3                   62624   6
jbd                    41092   6  [ext3]
cpqarray               19808   7
sd_mod                 11900   0  (unused)
scsi_mod               98584   1  [sd_mod]

root@ns3:/root
# lsmod
Module                  Size  Used by    Not tainted
autofs                 11556   0  (autoclean) (unused)
eepro100               17680   1
ext3                   62624   6
jbd                    41092   6  [ext3]
cpqarray               19808   7
sym53c8xx              57988   0  (unused)
sd_mod                 11900   0  (unused)
scsi_mod               98584   2  [sym53c8xx sd_mod]
Comment 4 Arjan van de Ven 2002-04-27 14:56:16 EDT
Ah ha!
but cciss is not scsi (well it doesn't use the kernel scsi layer, of course
you can connect scsi disks to it)
Comment 5 Jerry Williams 2002-04-27 15:00:14 EDT
This is a lie >I have gone back to kernel-2.4.7-10 and it works ok.<
What happened was I was on the console when I did this.  So I created entropy from the keyboard.
If I boot to 2.4.7-10 without using the console, cat /proc/sys/kernel/random/entropy_avail is 0.
So I would say that there is a SCSI or Compaq problem with all 7.2 i686 kernels as far as entropy goes.
Comment 6 Stefan Neufeind 2004-03-22 15:35:56 EST
please also here here:
https://bugzilla.redhat.com/bugzilla/show_bug.cgi?id=118921
Comment 7 Bugzilla owner 2004-09-30 11:39:32 EDT
Thanks for the bug report. However, Red Hat no longer maintains this version of
the product. Please upgrade to the latest version and open a new bug if the problem
persists.

The Fedora Legacy project (http://fedoralegacy.org/) maintains some older releases, 
and if you believe this bug is interesting to them, please report the problem in
the bug tracker at: http://bugzilla.fedora.us/

Note You need to log in before you can comment on or make changes to this bug.